#!/usr/bin/python

import csv,sys,os
import numpy as np
import networkx as nx
import matplotlib.pyplot as plt

ifile="data_network.csv"

with open(ifile,'rt') as testIn:
    testIn = csv.reader(testIn)
    headers = next(testIn)
    testes = [row for row in testIn]
 
TC=[]     	# Transnational Corporation
for i,j,k in testes:
    print (i)
    if i=='IPE':
        TC.append(j)

MNCs = list(set([row[0] for row in testes])) #takes the reduantices of the MNCs networks
 
id=list(enumerate(MNCs))# creates a list of tuples with unique ids and their names for each node in the network

keys = {name: i for i, name in enumerate(MNCs)} #creates a dictionary(hash map) that maps each id to the node names
 
links = [] #creates a blank list
 
ipe='#3bb6ef'
cor='k'
linkp='#f1fa11'

print(id[0])

linkColor=[]
linkWidth=[]

#maps all of the names in the csv file to their id number
for row in testes: 
    try:
        links.append([keys[row[0]], keys[row[1]]])
    except: 
        links.append([row[0], row[1]])
    
    if(row[0]=='IPE'):
        linkColor.append('k')
        linkWidth.append(1.0)
    elif row[0] in TC:
        linkColor.append(cor)
        linkWidth.append(0.2)
    else:
        linkWidth.append(0.2)
        if (row[2]=='2'):
            linkColor.append('#27d827')
        else:
            linkColor.append('#1d92ee')
 

nodeSize=[]
nodeColor=[]
nodeMark=[]

G = nx.Graph() #creates a graph
nodeId=[] #takes source and target edges
nc=0

tcn='#e2b80e'
nodep='b'
ct=0
for row in id:
    ct=ct+1
    nodeId.append(row[0])
    #>>>>> set size and color
    if(row[1]=='IPE'):
        nodeColor.append('k')
    elif row[1] in TC:
        nc=nc+1
        nodeColor.append(tcn)
    else:
        if (testes[ct][2]=='2'):
            nodeColor.append('#27d827')
        else:
            nodeColor.append('#1d92ee')

		
labels={}	# create dictionary for nx.draw_networkx_labels
labelIndex=[x for x, y in enumerate(id) if y[1] in TC]	# get node ID of TC
ipeIndex=[x for x, y in enumerate(id) if y[1]=='IPE']   # get node ID of IPE

# label TC from 1... and combine it to their id in dictionary
# give the labels of important nodes
n=0
for i in range(len(labelIndex)):
    n=i+1
    labels[labelIndex[i]] = id[labelIndex[i]][1] 

fig = plt.figure(figsize=(8.0, 5.0)) 
ax=fig.add_subplot(111)

G.add_nodes_from(nodeId)    #creates nodes for the graph.

m=0
for node in links: #loops through each link and changes each dictionary to a tuple so networkx can read in the information
    G.add_edge(node[0],node[1]) #takes the tuple from the list and unpacks the tuples
    m=m+1
 
# set the node size
d = dict(G.degree)
ns= [v * 3.5 for v in d.values()] # node size
ns[ipeIndex[0]]=500 #size of IPE node

pos=nx.spring_layout(G)
nx.draw_networkx_nodes(G,pos,node_size=ns,node_color=nodeColor)
nx.draw_networkx_edges(G,pos,edgelist=links,edge_color=linkColor,width=linkWidth)
nx.draw_networkx_labels(G,pos,labels,font_size=9,font_color='k')


ax.set_xticks([ ])
ax.set_yticks([ ])
ax.axis('off')
plt.tight_layout()
plt.savefig('fig-nwk-color.pdf',transparent=True)
plt.show(G)

